*$ CREATE USRMED.FOR
*COPY USRMED
*                                                                      *
*=== usrmed ===========================================================*
*                                                                      *
      SUBROUTINE USRMED ( IJ, EKSCO, PLA, WEE, MREG, NEWREG, XX, YY, ZZ,
     &                    TXX, TYY, TZZ )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'

      INTEGER IPRIN, IMPIN, IPPIN,IKPIN, ISPIN,IASPIN,IXPIN
      INTEGER IOPIN,ITPIN,IDPIN,IDPSIN,ILCPIN,IXCPIN,IXCPPIN
      INTEGER IPBIN,IMMIN,IPMIN,IKMIN,ISMIN,IASMIN,IXMIN
      INTEGER IOMIN,ITMIN,IDMIN,IDMSIN,ILCMIN,IXCMIN,IXCMPIN
      INTEGER IPROUT,IMPOUT,IPPOUT,IKPOUT,ISPOUT,IASPOUT,IXPOUT
      INTEGER IOPOUT,ITPOUT,IDPOUT,IDPSOUT,ILCPOUT,IXCPOUT,IXCPPOUT
      INTEGER IPBOUT,IMMOUT,IPMOUT,IKMOUT,ISMOUT,IASMOUT,IXMOUT
      INTEGER IOMOUT,ITMOUT,IDMOUT,IDMSOUT,ILCMOUT,IXCMOUT,IXCMPOUT

      INTEGER IHE4IN,IHE3IN,IH3IN,IH2IN
      INTEGER IHE4OUT,IHE3OUT,IH3OUT,IH2OUT

      INTEGER IPIN,IEIN
      INTEGER IPOUT,IEOUT
      INTEGER IGAMMAIN,IGAMMAOUT
      INTEGER INEUTRIN,INEUTROUT
      INTEGER IANEUTRIN,IANEUTROUT

      INTEGER IPRINEV,IMPINEV,IPPINEV,IKPINEV,ISPINEV,IASPINEV,IXPINEV
      INTEGER IOPINEV,ITPINEV,IDPINEV,IDPSINEV,ILCPINEV,IXCPINEV
      INTEGER IXCPPINEV
      INTEGER IPBINEV,IMMINEV,IPMINEV,IKMINEV,ISMINEV,IASMINEV,IXMINEV
      INTEGER IOMINEV,ITMINEV,IDMINEV,IDMSINEV,ILCMINEV,IXCMINEV
      INTEGER IXCMPINEV
      INTEGER IPROUTEV,IMPOUTEV,IPPOUTEV,IKPOUTEV,ISPOUTEV,IASPOUTEV
      INTEGER IXPOUTEV
      INTEGER IOPOUTEV,ITPOUTEV,IDPOUTEV,IDPSOUTEV,ILCPOUTEV,IXCPOUTEV
      INTEGER IXCPPOUTEV
      INTEGER IPBOUTEV,IMMOUTEV,IPMOUTEV,IKMOUTEV,ISMOUTEV,IASMOUTEV
      INTEGER IXMOUTEV
      INTEGER IOMOUTEV,ITMOUTEV,IDMOUTEV,IDMSOUTEV,ILCMOUTEV,IXCMOUTEV
      INTEGER IXCMPOUTEV

      INTEGER IHE4INEV,IHE3INEV,IH3INEV,IH2INEV
      INTEGER IHE4OUTEV,IHE3OUTEV,IH3OUTEV,IH2OUTEV

      INTEGER IPINEV,IEINEV
      INTEGER IPOUTEV,IEOUTEV
      INTEGER IGAMMAINEV,IGAMMAOUTEV
      INTEGER INEUTRINEV,INEUTROUTEV
      INTEGER IANEUTRINEV,IANEUTROUTEV

      INTEGER POSIN,NEGIN,POSOUT,NEGOUT,CHARGENET
      REAL*8 LAMBDANET
c      REAL*8 CHARGERATE
      INTEGER CHARGEEFF
      REAL*8 LAMBDAEFF
c      REAL*8 RATEEFF,SHOTNOISE

      INTEGER kkpart,ijpart,atomicN,massN
c      REAL*8 enkintot,pmom,fluxtime
      COMMON /NOEMI/ enkin,enkintot,pmom,xi,yi,zi,costx,costy,costz,
     &               fluxtime,kkpart,ijpart,atomicN,massN

      INTEGER atomicNold,massNold
      INTEGER kkold,ijold
c      REAL*8 enkintotold,pmomold

      INTEGER sumq2,IQEV,IQEV2
      INTEGER IQFLUXTIME

c--------------------------------------------------------------
c* NTUPLES:
c      PARAMETER (NNTUPLE=6) ! in usrmed
c      REAL*4 XTUP(nntuple) 

c-------- N. Finetti: ------------------------------------------------c
c
c OUPUT FILE: mist2.dat,status='unknown'. 
c
c Time interval setting: for the fluxtime value see usrmed*
c                        
c
c Modified 04 DEC 2007: COMMON /NOEMI/ to be shared with source* 
c                       with the values of
c                       kkpart,ijpart,atomicN,massN,enkintot,pmom,fluxtime.
c
c Modified 18 FEB 2008: GAMMAIN and GAMMAOUT.
c
c Modified 18 FEB 2008: in order to perform event-by-event analysis for the
c                       SHOTNOISE (CHARGEEF).
c
c Modified 26 FEB 2008: INEUTRIN and INEUTROUT (Neutrons).
c                       IANEUTRIN and IANEUTROUT (Anti-neutrons).
c
c Modified 27 Feb 2008: OUTPUT FILE charge.dat,status='unknown'.
c
c----------------------------------------------------------------------c
c----------------------------------------------------------------------c
c
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1991-2005      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     USeR MEDium dependent directives:                                *
*                                                                      *
*     Created on  10  may  1996    by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on   29-may-96   by    Alfredo Ferrari               *
*                                                                      *
*     Input variables:                                                 *
*             ij = particle id                                         *
*          Eksco = particle kinetic energy (GeV)                       *
*            Pla = particle momentum (GeV/c)                           *
*            Wee = particle weight                                     *
*           Mreg = (original) region number                            *
*         Newreg = (final)    region number                            *
*       Xx,Yy,Zz = particle position                                   *
*    Txx,Tyy,Tzz = particle direction                                  *
*                                                                      *
*     The user is supposed to change only WEE if MREG = NEWREG and     *
*     WEE, NEWREG, TXX, TYY, TZZ if MREG .NE. NEWREG                   *
*                                                                      *
*----------------------------------------------------------------------*
*

      OPEN(22,
     +FILE=
     +'/lisa-pf/prova_lngs/check_fluka/'//
     +'mist2.dat',
     +status='unknown')

c Modified 27 Feb 2008 -------------------------------------------------
      OPEN(23,
     +FILE=
     +'/lisa-pf/prova_lngs/check_fluka/'//
     +'charge.dat',
     +status='unknown')
c-----------------------------------------------------------------------
c
c Modified 18 Feb 2008 -------------------------
      IF((mreg.eq.7.and.newreg.eq.8.).or.
     +   (mreg.eq.8.and.newreg.eq.7.)) THEN
c      IF((mreg.eq.6.and.newreg.eq.7.).or.
c     +   (mreg.eq.7.and.newreg.eq.6.)) THEN

      if(kkold.eq.0) then
      IQEV=0
      CHARGENET=0
      CHARGEEFF=0
      IQFLUXTIME=0
      FLUXTIMEOLD=0
      endif

      if((kkold.ne.0).and.(kkold.lt.kkpart)) then
      write(22,*)'******************** OLD BEAM ********************'
      write(22,*)'    '
      write(22,*)'---------------------'
      write(22,33)kkold,ijold
 33   format('Incident particle ID:',i10,'     Beam particle type:',i4)
      write(22,34)atomicNold,massNold
 34   format('Atomic N. =',i4,'     Atomic Mass N. =',i4)
      write(22,35)enkintotold,pmomold
 35   format('Tot. Kin. En. =',1f10.3,'     Momentum =',1f10.3)
      write(22,*)'---------------------' 

      POSIN=IPRINEV+IMPINEV+IPPINEV+IKPINEV+ISPINEV+IASPINEV+IXPINEV+
     +IOPINEV+
     +ITPINEV+IDPINEV+IDPSINEV+ILCPINEV+IXCPINEV+IXCPPINEV+IPINEV+
     +2*IHE4INEV+2*IHE3INEV+IH3INEV+IH2INEV

      NEGIN=IPBINEV+IMMINEV+IPMINEV+IKMINEV+ISMINEV+IASMINEV+IXMINEV+
     +IOMINEV+ITMINEV+IDMINEV+IDMSINEV+ILCMINEV+IXCMINEV+IXCMPINEV+
     +IEINEV

      POSOUT=IPROUTEV+IMPOUTEV+IPPOUTEV+IKPOUTEV+ISPOUTEV+IASPOUTEV+
     +IXPOUTEV+IOPOUTEV+
     +ITPOUTEV+IDPOUTEV+IDPSOUTEV+ILCPOUTEV+IXCPOUTEV+IXCPPOUTEV+
     +IPOUTEV+
     +2*IHE4OUTEV+2*IHE3OUTEV+IH3OUTEV+IH2OUTEV

      NEGOUT=IPBOUTEV+IMMOUTEV+IPMOUTEV+IKMOUTEV+ISMOUTEV+IASMOUTEV+
     +IXMOUTEV+
     +IOMOUTEV+ITMOUTEV+IDMOUTEV+IDMSOUTEV+ILCMOUTEV+IXCMOUTEV+
     +IXCMPOUTEV+IEOUTEV

      IQFLUXTIME=IQFLUXTIME+(POSIN-NEGIN-POSOUT+NEGOUT) ! intero

      IQEV=(POSIN-NEGIN-POSOUT+NEGOUT) ! intero
c      CHARGENET=CHARGENET+(POSIN-NEGIN-POSOUT+NEGOUT) ! intero
      CHARGENET=CHARGENET+IQEV ! intero
      IF(FLUXTIMEOLD.NE.0.) THEN
      LAMBDANET=CHARGENET/FLUXTIMEOLD ! in s-1
      ENDIF
      CHARGERATE=LAMBDANET ! in e/s

      write(22,*)'    '
      write(22,36)CHARGENET,FLUXTIMEOLD
 36   format('Test mass net charge:',
     +1x,i10,'e     time:',1x,f12.5,'s')
      write(22,37)CHARGERATE
 37   format('Test mass net charging rate (e*lambda_net):',
     +1x,f12.7,'e/s')
      write(22,*)'    '

      IQEV2=(POSIN-NEGIN-POSOUT+NEGOUT)**2 ! intero
c      CHARGEEFF=CHARGEEFF+(POSIN-NEGIN-POSOUT+NEGOUT)**2 ! intero
      CHARGEEFF=CHARGEEFF+IQEV2 ! intero
      SUMQ2=CHARGEEFF

      IF(FLUXTIMEOLD.NE.0.) THEN
      LAMBDAEFF=CHARGEEFF/FLUXTIMEOLD ! in s-1
      ENDIF
      RATEEFF=LAMBDAEFF ! in [e**2/s]

      SHOTNOISE=sqrt(2.0*RATEEFF) ! in [e/s/Hz**0.5] 
      
      write(22,13)SUMQ2
 13   format('Sum_q**2 =',1x,i10,1x,'e**2')
      write(22,39)RATEEFF
 39   format('Effective rate of single charges ',1x,
     +'R_eff=e**2*lambda_eff:',
     +1x,f12.7,'e**2/s')
      write(22,40)SHOTNOISE
 40   format('Spectral density of the shot noise S_R=sqrt(2*R_eff):',
     +1x,f12.7,'[e/s/Hz**0.5]')
      write(22,*)'    '
      write(22,*)'---------------------'
      write(22,*)'    '
      write(22,*)'PREVIOUS USRMED RESULT ...'
      write(22,*)'    '
      write(22,33)kkold,ijold
      write(22,*)'    '
      write(22,*)
     +'Updating of the test mass INPUT CHARGED PARTICLES ...'
      write(22,*)'   '
      write(22,74) IHE4IN,IHE3IN,IH3IN,IH2IN  
      write(22,76) IPIN
      write(22,77) IPRIN,IMPIN,IPPIN,IKPIN 
      write(22,78) ISPIN,IASPIN,IXPIN,IOPIN 
      write(22,79) ITPIN,IDPIN,IDPSIN,ILCPIN 
      write(22,80) IXCPIN, IXCPPIN
      write(22,66) IEIN
      write(22,81) IPBIN,IMMIN,IPMIN,IKMIN 
      write(22,82) ISMIN,IASMIN,IXMIN,IOMIN
      write(22,83) ITMIN,IDMIN,IDMSIN,ILCMIN
      write(22,84) IXCMIN, IXCMPIN
      write(22,*)'    '
      write(22,*)
     +'Updating of the test mass OUTPUT CHARGED PARTICLES ...'
      write(22,*)'   '
      write(22,75) IHE4OUT,IHE3OUT,IH3OUT,IH2OUT
      write(22,93) IPOUT
      write(22,85) IPROUT,IMPOUT,IPPOUT,IKPOUT
      write(22,86) ISPOUT,IASPOUT,IXPOUT,IOPOUT
      write(22,87) ITPOUT,IDPOUT,IDPSOUT,ILCPOUT
      write(22,88) IXCPOUT, IXCPPOUT
      write(22,56) IEOUT
      write(22,89) IPBOUT,IMMOUT,IPMOUT,IKMOUT
      write(22,90) ISMOUT,IASMOUT,IXMOUT,IOMOUT
      write(22,91) ITMOUT,IDMOUT,IDMSOUT,ILCMOUT
      write(22,92) IXCMOUT, IXCMPOUT
      write(22,*)'    '
      write(22,*)
     +'Updating of the test mass INPUT NEUTRAL PARTICLES ...'
      write(22,*)'   '
      write(22,94) IGAMMAIN
      write(22,14) INEUTRIN
       write(22,16) IANEUTRIN
      write(22,*)'   '
      write(22,*)
     +'Updating of the test mass OUTPUT NEUTRAL PARTICLES ...'
      write(22,*)'   '
      write(22,95) IGAMMAOUT
      write(22,15) INEUTROUT
      write(22,17) IANEUTROUT
      write(22,*)'    '
      write(22,*)'    '
      write(22,*)'**************************************************'
ccc N.F. 24 November 2008!
      close(22)

      write(23,51)kkold,IQEV,fluxtimeold,iqfluxtime,LAMBDANET,LAMBDAEFF
c 51   format(i10,i10)
c 51   format(i10,i10,f10.5,i10)
 51   format(1x,i10,1x,i10,1x,f12.5,1x,i10,1x,f12.7,1x,f12.7)

c Ntuples:
c      XTUP(1)=kkold
c      XTUP(2)=IQEV
c      XTUP(3)=fluxtimeold
c      XTUP(4)=iqfluxtime
c      XTUP(5)=LAMBDANET
c      XTUP(6)=LAMBDAEFF
c      CALL HFN(100,XTUP)
cc
      endif

      if(kkold.lt.kkpart) then

      POSIN=0
      NEGIN=0
      POSOUT=0
      NEGOUT=0
      IQEV=0
      IQEV2=0

      IGAMMAINEV=0
      INEUTRINEV=0
      IANEUTRINEV=0
      IPRINEV=0
      IMPINEV=0
      IPPINEV=0
      IKPINEV=0
      ISPINEV=0
      IASPINEV=0
      IXPINEV=0
      IOPINEV=0
      ITPINEV=0
      IDPINEV=0
      IDPSINEV=0
      ILCPINEV=0
      IXCPINEV=0
      IXCPPINEV=0
      IPBINEV=0
      IMMINEV=0
      IPMINEV=0
      IKMINEV=0
      ISMINEV=0
      IASMINEV=0
      IXMINEV=0
      IOMINEV=0
      ITMINEV=0
      IDMINEV=0
      IDMSINEV=0
      ILCMINEV=0
      IXCMINEV=0
      IXCMPINEV=0
      IPINEV=0
      IEINEV=0
      IHE4INEV=0
      IHE3INEV=0
      IH3INEV=0
      IH2INEV=0

      IGAMMAOUTEV=0
      INEUTROUTEV=0
      IANEUTROUTEV=0
      IPROUTEV=0
      IMPOUTEV=0
      IPPOUTEV=0
      IKPOUTEV=0
      ISPOUTEV=0
      IASPOUTEV=0
      IXPOUTEV=0
      IOPOUTEV=0
      ITPOUTEV=0
      IDPOUTEV=0
      IDPSOUTEV=0
      ILCPOUTEV=0
      IXCPOUTEV=0
      IXCPPOUTEV=0
      IPBOUTEV=0
      IMMOUTEV=0
      IPMOUTEV=0
      IKMOUTEV=0
      ISMOUTEV=0
      IASMOUTEV=0
      IXMOUTEV=0
      IOMOUTEV=0
      ITMOUTEV=0
      IDMOUTEV=0
      IDMSOUTEV=0
      ILCMOUTEV=0
      IXCMOUTEV=0
      IXCMPOUTEV=0
      IPOUTEV=0
      IEOUTEV=0
      IHE4OUTEV=0
      IHE3OUTEV=0
      IH3OUTEV=0
      IH2OUTEV=0
      endif

      ENDIF
c End 18 Feb 2008

      if(mreg.eq.7.and.newreg.eq.8.) then
c      if(mreg.eq.6.and.newreg.eq.7.) then

C
C     GAMMA IN
C
      if(ij.eq.7) then
      IGAMMAIN=IGAMMAIN+1
      IGAMMAINEV=IGAMMAINEV+1
      endif
C
C     NEUTRONI IN
C
      if(ij.eq.8) then
      INEUTRIN=INEUTRIN+1
      INEUTRINEV=INEUTRINEV+1
      endif
C
C     ANTI-NEUTRONI IN
C
      if(ij.eq.9) then
      IANEUTRIN=IANEUTRIN+1
      IANEUTRINEV=IANEUTRINEV+1
      endif
C
C     BARIONI POSITIVI IN
C            
      if(ij.eq.1) then 
      IPRIN=IPRIN+1
      IPRINEV=IPRINEV+1
      endif
      if(ij.eq.10) then
      IMPIN=IMPIN+1
      IMPINEV=IMPINEV+1
      endif
      if(ij.eq.13) then
      IPPIN=IPPIN+1
      IPPINEV=IPPINEV+1
      endif 
      if(ij.eq.15) then
      IKPIN=IKPIN+1
      IKPINEV=IKPINEV+1
      endif
      if(ij.eq.21) then
      ISPIN=ISPIN+1
      ISPINEV=ISPINEV+1
      endif
      if(ij.eq.33) then
      IASPIN=IASPIN+1
      IASPINEV=IASPINEV+1
      endif
      if(ij.eq.37) then
      IXPIN=IXPIN+1
      IXPINEV=IXPINEV+1
      endif
      if(ij.eq.39) then
      IOPIN=IOPIN+1
      IOPINEV=IOPINEV+1
      endif 
      if(ij.eq.41) then
      ITPIN=ITPIN+1
      ITPINEV=ITPINEV+1
      endif
      if(ij.eq.45) then
      IDPIN=IDPIN+1
      IDPINEV=IDPINEV+1
      endif 
      if(ij.eq.49) then
      IDPSIN=IDPSIN+1
      IDPSINEV=IDPSINEV+1
      endif
      if(ij.eq.51) then
      ILCPIN=ILCPIN+1
      ILCPINEV=ILCPINEV+1
      endif
      if(ij.eq.52) then
      IXCPIN=IXCPIN+1
      IXCPINEV=IXCPINEV+1
      endif 
      if(ij.eq.54) then
      IXCPPIN=IXCPPIN+1
      IXCPPINEV=IXCPPINEV+1
      endif
C
C     BARIONI NEGATIVI IN
C
      if(ij.eq.2) then 
      IPBIN=IPBIN+1
      IPBINEV=IPBINEV+1
      endif
      if(ij.eq.11) then
      IMMIN=IMMIN+1
      IMMINEV=IMMINEV+1
      endif
      if(ij.eq.14) then
      IPMIN=IPMIN+1
      IPMINEV=IPMINEV+1
      endif 
      if(ij.eq.16) then
      IKMIN=IKMIN+1
      IKMINEV=IKMINEV+1
      endif
      if(ij.eq.20) then
      ISMIN=ISMIN+1
      ISMINEV=ISMINEV+1
      endif
      if(ij.eq.31) then
      IASMIN=IASMIN+1
      IASMINEV=IASMINEV+1
      endif
      if(ij.eq.36) then
      IXMIN=IXMIN+1
      IXMINEV=IXMINEV+1
      endif
      if(ij.eq.38) then
      IOMIN=IOMIN+1
      IOMINEV=IOMINEV+1
      endif 
      if(ij.eq.42) then
      ITMIN=ITMIN+1
      ITMINEV=ITMINEV+1
      endif
      if(ij.eq.46) then
      IDMIN=IDMIN+1
      IDMINEV=IDMINEV+1
      endif 
      if(ij.eq.50) then
      IDMSIN=IDMSIN+1
      IDMSINEV=IDMSINEV+1
      endif
      if(ij.eq.57) then
      ILCMIN=ILCMIN+1
      ILCMINEV=ILCMINEV+1
      endif
      if(ij.eq.58) then
      IXCMIN=IXCMIN+1
      IXCMINEV=IXCMINEV+1
      endif 
      if(ij.eq.60) then
      IXCMPIN=IXCMPIN+1
      IXCMPINEV=IXCMPINEV+1
      endif

C     POSITRONI ED ELETTRONI IN

      if(ij.eq.4) then 
      IPIN=IPIN+1
      IPINEV=IPINEV+1
      endif
      if(ij.eq.3) then
      IEIN=IEIN+1
      IEINEV=IEINEV+1
      endif
      
C     NUCLEI PESANTI IN

      if(ij.eq.-6) then 
      IHE4IN=IHE4IN+1
      IHE4INEV=IHE4INEV+1
      endif
      if(ij.eq.-5) then
      IHE3IN=IHE3IN+1
      IHE3INEV=IHE3INEV+1
      endif
      if(ij.eq.-4) then 
      IH3IN=IH3IN+1
      IH3INEV=IH3INEV+1
      endif
      if(ij.eq.-3) then
      IH2IN=IH2IN+1
      IH2INEV=IH2INEV+1
      endif


      endif

      if(mreg.eq.8.and.newreg.eq.7.) then
c      if(mreg.eq.7.and.newreg.eq.6.) then

C
C     GAMMA OUT
C
      if(ij.eq.7) then
      IGAMMAOUT=IGAMMAOUT+1
      IGAMMAOUTEV=IGAMMAOUTEV+1
      endif
C
C     NEUTRONI OUT
C
      if(ij.eq.8) then
      INEUTROUT=INEUTROUT+1
      INEUTROUTEV=INEUTROUTEV+1
      endif
C
C     ANTI-NEUTRONI OUT
C
      if(ij.eq.9) then
      IANEUTROUT=IANEUTROUT+1
      IANEUTROUTEV=IANEUTROUTEV+1
      endif
C
C     BARIONI POSITIVI OUT
C      
      if(ij.eq.1) then 
      IPROUT=IPROUT+1
      IPROUTEV=IPROUTEV+1
      endif
      if(ij.eq.10) then
      IMPOUT=IMPOUT+1
      IMPOUTEV=IMPOUTEV+1
      endif
      if(ij.eq.13) then
      IPPOUT=IPPOUT+1
      IPPOUTEV=IPPOUTEV+1
      endif 
      if(ij.eq.15) then
      IKPOUT=IKPOUT+1
      IKPOUTEV=IKPOUTEV+1
      endif
      if(ij.eq.21) then
      ISPOUT=ISPOUT+1
      ISPOUTEV=ISPOUTEV+1
      endif
      if(ij.eq.33) then
      IASPOUT=IASPOUT+1
      IASPOUTEV=IASPOUTEV+1
      endif
      if(ij.eq.37) then
      IXPOUT=IXPOUT+1
      IXPOUTEV=IXPOUTEV+1
      endif
      if(ij.eq.39) then
      IOPOUT=IOPOUT+1
      IOPOUTEV=IOPOUTEV+1
      endif 
      if(ij.eq.41) then
      ITPOUT=ITPOUT+1
      ITPOUTEV=ITPOUTEV+1
      endif
      if(ij.eq.45) then
      IDPOUT=IDPOUT+1
      IDPOUTEV=IDPOUTEV+1
      endif 
      if(ij.eq.49) then
      IDPSOUT=IDPSOUT+1
      IDPSOUTEV=IDPSOUTEV+1
      endif
      if(ij.eq.51) then
      ILCPOUT=ILCPOUT+1
      ILCPOUTEV=ILCPOUTEV+1
      endif
      if(ij.eq.52) then
      IXCPOUT=IXCPOUT+1
      IXCPOUTEV=IXCPOUTEV+1
      endif 
      if(ij.eq.54) then
      IXCPPOUT=IXCPPOUT+1
      IXCPPOUTEV=IXCPPOUTEV+1
      endif
C
C     BARIONI NEGATIVI OUT
C
      if(ij.eq.2) then 
      IPBOUT=IPBOUT+1
      IPBOUTEV=IPBOUTEV+1
      endif
      if(ij.eq.11) then
      IMMOUT=IMMOUT+1
      IMMOUTEV=IMMOUTEV+1
      endif
      if(ij.eq.14) then
      IPMOUT=IPMOUT+1
      IPMOUTEV=IPMOUTEV+1
      endif 
      if(ij.eq.16) then
      IKMOUT=IKMOUT+1
      IKMOUTEV=IKMOUTEV+1
      endif
      if(ij.eq.20) then
      ISMOUT=ISMOUT+1
      ISMOUTEV=ISMOUTEV+1
      endif
      if(ij.eq.31) then
      IASMOUT=IASMOUT+1
      IASMOUTEV=IASMOUTEV+1
      endif
      if(ij.eq.36) then
      IXMOUT=IXMOUT+1
      IXMOUTEV=IXMOUTEV+1
      endif
      if(ij.eq.38) then
      IOMOUT=IOMOUT+1
      IOMOUTEV=IOMOUTEV+1
      endif 
      if(ij.eq.42) then
      ITMOUT=ITMOUT+1
      ITMOUTEV=ITMOUTEV+1
      endif
      if(ij.eq.46) then
      IDMOUT=IDMOUT+1
      IDMOUTEV=IDMOUTEV+1
      endif 
      if(ij.eq.50) then
      IDMSOUT=IDMSOUT+1
      IDMSOUTEV=IDMSOUTEV+1
      endif
      if(ij.eq.57) then
      ILCMOUT=ILCMOUT+1
      ILCMOUTEV=ILCMOUTEV+1
      endif
      if(ij.eq.58) then
      IXCMOUT=IXCMOUT+1
      IXCMOUTEV=IXCMOUTEV+1
      endif 
      if(ij.eq.60) then
      IXCMPOUT=IXCMPOUT+1
      IXCMPOUTEV=IXCMPOUTEV+1
      endif



C POSITRONI ED ELETTRONI OUT

      if(ij.eq.4) then 
      IPOUT=IPOUT+1
      IPOUTEV=IPOUTEV+1
      endif
      if(ij.eq.3) then
      IEOUT=IEOUT+1
      IEOUTEV=IEOUTEV+1
      endif

C     NUCLEI PESANTI OUT

      if(ij.eq.-6) then 
      IHE4OUT=IHE4OUT+1
      IHE4OUTEV=IHE4OUTEV+1
      endif
      if(ij.eq.-5) then
      IHE3OUT=IHE3OUT+1
      IHE3OUTEV=IHE3OUTEV+1
      endif
      if(ij.eq.-4) then 
      IH3OUT=IH3OUT+1
      IH3OUTEV=IH3OUTEV+1
      endif
      if(ij.eq.-3) then
      IH2OUT=IH2OUT+1
      IH2OUTEV=IH2OUTEV+1
      endif


      endif

      if((mreg.eq.7.and.newreg.eq.8.).or.
     +   (mreg.eq.8.and.newreg.eq.7.))then
c      if((mreg.eq.6.and.newreg.eq.7.).or.
c     +   (mreg.eq.7.and.newreg.eq.6.))then

ccc N.F. 24 November 2008
c      write(22,*)'    '
c      write(22,*)'Calling USRMED!!!'
c      write(22,*)'    '
c      write(22,*)'Beam particle type:'
c      write(22,71)ijpart
c      write(22,*)'Beam particle N.:'
c      write(22,71)kkpart
c      write(22,*)'    '
c      write(22,*)'Crossing particle id:'
c      write(22,71) ij
c      write(22,*)'Original region n.:'
c      write(22,71) mreg
c      write(22,*)'Final region n.:'
c      write(22,71) newreg
 71   format(5x, 1i8)
c      write(22,*)
c     +'Updating of the test mass INPUT CHARGED PARTICLES ...'
c      write(22,*)'   '
c      write(22,74) IHE4IN,IHE3IN,IH3IN,IH2IN  
 74   format('HE4-HE3-T-D IN', 2x, 2i10,5x,2i10)
c      write(22,76) IPIN
 76   format('Positrons IN', 2x, i10)
c      write(22,77) IPRIN,IMPIN,IPPIN,IKPIN 
 77   format('PR-MU+-PI+-K+ IN', 2x, 4i10)
c      write(22,78) ISPIN,IASPIN,IXPIN,IOPIN 
 78   format('S+-AS+-X+-O+ IN', 2x, 4i10)
c      write(22,79) ITPIN,IDPIN,IDPSIN,ILCPIN 
 79   format('TP-DP-DSP-LCP IN', 2x, 4i10)
c      write(22,80) IXCPIN, IXCPPIN 
 80   format('XCP-XCPP IN', 2x, 2i10)
c      write(22,66) IEIN
 66   format('Electrons IN', 2x, i10)
c      write(22,81) IPBIN,IMMIN,IPMIN,IKMIN 
 81   format('PB-MU--PI--K- IN', 2x, 4i10)
c      write(22,82) ISMIN,IASMIN,IXMIN,IOMIN 
 82   format('S--AS--X--O- IN', 2x, 4i10)
c      write(22,83) ITMIN,IDMIN,IDMSIN,ILCMIN 
 83   format('TM-DM-DSM-LCM IN', 2x, 4i10)
c      write(22,84) IXCMIN, IXCMPIN
 84   format('XCM-XCMP IN', 2x, 2i10)      
c      write(22,*)'    '
c      write(22,*)
c     +'Updating of the test mass OUTPUT CHARGED PARTICLES ...'
c      write(22,*)'   '
c      write(22,75) IHE4OUT,IHE3OUT,IH3OUT,IH2OUT  
 75   format('HE4-HE3-T-D OUT', 2x, 2i10,5x,2i10)
c      write(22,93) IPOUT
 93   format('Positrons OUT', 2x, i10)
c      write(22,85) IPROUT,IMPOUT,IPPOUT,IKPOUT 
 85   format('PR-MU+-PI+-K+ OUT', 2x, 4i10)
c      write(22,86) ISPOUT,IASPOUT,IXPOUT,IOPOUT 
 86   format('S+-AS+-X+-O+ OUT', 2x, 4i10)
c      write(22,87) ITPOUT,IDPOUT,IDPSOUT,ILCPOUT 
 87   format('TP-DP-DSP-LCP OUT', 2x, 4i10)
c      write(22,88) IXCPOUT, IXCPPOUT 
 88   format('XCP-XCPP OUT', 2x, 2i10)
c      write(22,56) IEOUT
 56   format('Electrons OUT', 2x, i10)
c      write(22,89) IPBOUT,IMMOUT,IPMOUT,IKMOUT 
 89   format('PB-MU--PI--K- OUT', 2x, 4i10)
c      write(22,90) ISMOUT,IASMOUT,IXMOUT,IOMOUT 
 90   format('S--AS--X--O- OUT', 2x, 4i10)
c      write(22,91) ITMOUT,IDMOUT,IDMSOUT,ILCMOUT 
 91   format('TM-DM-DSM-LCM OUT', 2x, 4i10)
c      write(22,92) IXCMOUT, IXCMPOUT 
 92   format('XCM-XCMP OUT', 2x, 2i10)
c      write(22,*)'    '
c      write(22,*)
c     +'Updating of the test mass INPUT NEUTRAL PARTICLES ...'
c      write(22,*)'   '
c      write(22,94) IGAMMAIN
 94   format('Gamma-rays IN',2x,i10)
c      write(22,14) INEUTRIN
 14   format('Neutrons IN',2x,i10)
c       write(22,16) IANEUTRIN
 16    format('Anti-Neutrons IN',2x,i10)
c      write(22,*)'   '
c      write(22,*)
c     +'Updating of the test mass OUTPUT NEUTRAL PARTICLES ...'
c      write(22,*)'   '
c      write(22,95) IGAMMAOUT
 95   format('Gamma-rays OUT',2x,i10)
c      write(22,15) INEUTROUT
 15   format('Neutrons OUT',2x,i10)
c      write(22,17) IANEUTROUT
 17   format('Anti-Neutrons OUT',2x,i10)
c      write(22,*)'    '
ccc
      kkold=kkpart
      ijold=ijpart
      atomicNold=atomicN
      massNold=massN
      enkintotold=enkintot
      pmomold=pmom
      FLUXTIMEOLD=FLUXTIME

      endif

      RETURN
*=== End of subroutine Usrmed =========================================*
      END

